commit 4604348741386dcb4979a80e1d289ccbdbdeb033
Author: Iain Buclaw <ibuclaw@gdcproject.org>
Date:   Sun Oct 11 22:20:43 2020 +0200

    d: Fix alias protection being ignored if used before declaration.
    
    Fixes a symbol resolver bug where a private alias becomes public if used
    before its declaration.
    
    gcc/d/ChangeLog:
    
    2020-10-12  Iain Buclaw  <ibuclaw@gdcproject.org>
    
            * dmd/declaration.c (AliasDeclaration::aliasSemantic): Apply storage
            class and protection attributes.
    
    gcc/testsuite/ChangeLog:
    
    2020-10-12  Iain Buclaw  <ibuclaw@gdcproject.org>
    
            * gdc.test/fail_compilation/fail21001.d: New test.
            * gdc.test/fail_compilation/imports/fail21001b.d: New test.
            * gdc.test/fail_compilation/imports/issue21295ast_node.d: New test.
            * gdc.test/fail_compilation/imports/issue21295astcodegen.d: New test.
            * gdc.test/fail_compilation/imports/issue21295dtemplate.d: New test.
            * gdc.test/fail_compilation/imports/issue21295visitor.d: New test.
            * gdc.test/fail_compilation/issue21295.d: New test.
    
    (cherry picked from commit c3249210b0108b5fc2dc403e558ab63882293be4)

diff --git a/gcc/d/dmd/declaration.c b/gcc/d/dmd/declaration.c
index 2ad6af2d410..5dc76e1cc4b 100644
--- a/gcc/d/dmd/declaration.c
+++ b/gcc/d/dmd/declaration.c
@@ -340,6 +340,13 @@ void AliasDeclaration::semantic(Scope *sc)
 void AliasDeclaration::aliasSemantic(Scope *sc)
 {
     //printf("AliasDeclaration::semantic() %s\n", toChars());
+
+    // as AliasDeclaration::semantic, in case we're called first.
+    // see https://issues.dlang.org/show_bug.cgi?id=21001
+    storage_class |= sc->stc & STCdeprecated;
+    protection = sc->protection;
+    userAttribDecl = sc->userAttribDecl;
+
     // TypeTraits needs to know if it's located in an AliasDeclaration
     sc->flags |= SCOPEalias;
 
diff --git a/gcc/testsuite/gdc.test/fail_compilation/fail21001.d b/gcc/testsuite/gdc.test/fail_compilation/fail21001.d
new file mode 100644
index 00000000000..0faeb4038ef
--- /dev/null
+++ b/gcc/testsuite/gdc.test/fail_compilation/fail21001.d
@@ -0,0 +1,12 @@
+/*
+TEST_OUTPUT:
+---
+fail_compilation/fail21001.d(12): Error: undefined identifier `Alias`
+---
+*/
+
+module fail21001;
+
+import imports.fail21001b;
+
+void main() { Alias var; }
diff --git a/gcc/testsuite/gdc.test/fail_compilation/imports/fail21001b.d b/gcc/testsuite/gdc.test/fail_compilation/imports/fail21001b.d
new file mode 100644
index 00000000000..69c1c20a356
--- /dev/null
+++ b/gcc/testsuite/gdc.test/fail_compilation/imports/fail21001b.d
@@ -0,0 +1,5 @@
+module imports.fail21001b;
+
+private struct S { Alias member; }
+
+private alias Alias = int;
diff --git a/gcc/testsuite/gdc.test/fail_compilation/imports/issue21295ast_node.d b/gcc/testsuite/gdc.test/fail_compilation/imports/issue21295ast_node.d
new file mode 100644
index 00000000000..d9298bf972d
--- /dev/null
+++ b/gcc/testsuite/gdc.test/fail_compilation/imports/issue21295ast_node.d
@@ -0,0 +1,5 @@
+module imports.issue21295ast_node;
+import imports.issue21295visitor : Visitor;
+class ASTNode {
+    void accept(Visitor);
+}
diff --git a/gcc/testsuite/gdc.test/fail_compilation/imports/issue21295astcodegen.d b/gcc/testsuite/gdc.test/fail_compilation/imports/issue21295astcodegen.d
new file mode 100644
index 00000000000..5eccf6ac028
--- /dev/null
+++ b/gcc/testsuite/gdc.test/fail_compilation/imports/issue21295astcodegen.d
@@ -0,0 +1,4 @@
+module imports.issue21295astcodegen;
+struct ASTCodegen {
+    import imports.issue21295dtemplate;
+}
diff --git a/gcc/testsuite/gdc.test/fail_compilation/imports/issue21295dtemplate.d b/gcc/testsuite/gdc.test/fail_compilation/imports/issue21295dtemplate.d
new file mode 100644
index 00000000000..8864f9ea27e
--- /dev/null
+++ b/gcc/testsuite/gdc.test/fail_compilation/imports/issue21295dtemplate.d
@@ -0,0 +1,3 @@
+module imports.issue21295dtemplate;
+import imports.issue21295ast_node;
+class TemplateParameter : ASTNode { }
diff --git a/gcc/testsuite/gdc.test/fail_compilation/imports/issue21295visitor.d b/gcc/testsuite/gdc.test/fail_compilation/imports/issue21295visitor.d
new file mode 100644
index 00000000000..3665a7fe8c2
--- /dev/null
+++ b/gcc/testsuite/gdc.test/fail_compilation/imports/issue21295visitor.d
@@ -0,0 +1,3 @@
+module imports.issue21295visitor;
+import imports.issue21295astcodegen;
+class Visitor { }
diff --git a/gcc/testsuite/gdc.test/fail_compilation/issue21295.d b/gcc/testsuite/gdc.test/fail_compilation/issue21295.d
new file mode 100644
index 00000000000..9916e9ba2a7
--- /dev/null
+++ b/gcc/testsuite/gdc.test/fail_compilation/issue21295.d
@@ -0,0 +1,9 @@
+/*
+REQUIRED_ARGS: -de
+TEST_OUTPUT:
+---
+fail_compilation/issue21295.d(9): Deprecation: imports.issue21295ast_node.Visitor is not visible from module issue21295
+---
+*/
+import imports.issue21295ast_node;
+Visitor should_fail;

